/*
 * AllTypes.h
 *
 * Generated by SILECS framework tools 
 */

#ifndef AllTypes_AllTypes_H_
#define AllTypes_AllTypes_H_

#include <silecs-communication/interface/core/SilecsService.h>
#include <fesa-core/Synchronization/MultiplexingContext.h>
#include <AllTypes/GeneratedCode/ServiceLocator.h>

namespace AllTypes
{

    /*---------------------------------------------------------------------------------------------------------
     * SETUP
     *---------------------------------------------------------------------------------------------------------
     *  Setup the SILECS service by calling the setup() method from the RTDeviceClass::specificInit()
     *  Stop and cleanup the SILECS service by calling the cleanup() method if needed (eg.: from ~RTDeviceClass())
     *
     *  In order to make use of the different blocks, defined in the silecsdesign, please make use of the static, block related variables of the class, defined on the bottom of this file !
     * --------------------------------------------------------------------------------------------------------
     */

    /*---------------------------------------------------------------------------------------------------------
     * COMMUNICATION
     *---------------------------------------------------------------------------------------------------------
     * General methods to synchronize the FESA fields and related PLC registers of the FESA server with or without
     * PLC side synchronization (send/recv) if requested. Each action is done for one particular block.
     * In case of BLOCK_MODE configuration (see SILECS doc.), the transaction is optimal with the following
     * 'AllDevices' and 'PLCDevices' methods.
     * Each method can be called in the appropriate server-action (set) and rt-action (get)
     *
     * getAllDevices  : [receive all devices of all connected PLCs +] update FESA fields with related SILECS registers
     * setAllDevices  : update SILECS registers with related FESA fields [+ send block to all connected PLCs]
     * getPLCDevices  : [receive all devices of one PLC +] update FESA fields with related SILECS registers
     * setPLCDevices  : update SILECS registers with related FESA fields [+ send block to the PLC]
     * getSomeDevices : [receive each device of the device-collection +] update FESA fields with related SILECS registers
     * setSomeDevices : update SILECS registers with related FESA fields [+ send block to each device of the device-collection]
     * getOneDevice   : [receive block of one PLC device +] update FESA fields with related SILECS registers
     * setOneDevice   : update SILECS registers with related FESA fields [+ send block to the PLC device]
     *
     * --------------------------------------------------------------------------------------------------------
     */

    class AbstractAllTypes
    {
        public:
            static inline Silecs::Service* theService()  { return pService_; }
            static inline Silecs::Cluster* theCluster()  { return pCluster_; }
            inline std::string& getBlockName()          { return blockName_; }

            static void setup(const ServiceLocator* serviceLocator);
            static void cleanup();
            static bool isInitialized(){ return AbstractAllTypes::isInitialized_; }
            static void updatePLCRegisters(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator);
            static void updateFesaFields(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator);

            AbstractAllTypes(std::string blockName);
            virtual ~AbstractAllTypes();

            void getAllDevices(const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext);
            void getPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext);
            void getSomeDevices(std::vector<Device*> deviceCol, const bool recvNow, MultiplexingContext* pContext);
            virtual void getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext);

            void setAllDevices(const ServiceLocator* serviceLocator, const bool sendNow, MultiplexingContext* pContext);
            void setPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, const bool sendNow, MultiplexingContext* pContext);
            void setSomeDevices(std::vector<Device*> deviceCol, const bool sendNow, MultiplexingContext* pContext);
            virtual void setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext);

        protected:

            static Silecs::Service* pService_;
            static Silecs::Cluster* pCluster_;
            static bool isInitialized_;

            // Name of the silecs-block which is addressed
            std::string blockName_;

            // not copyable object
            AbstractAllTypes(const AbstractAllTypes&);
            AbstractAllTypes& operator=(const AbstractAllTypes&);
    };

    // -------------------------------------------------------------------------------------------------
    #define BLOCK_RO( blockName, propName )	\
    class blockName##_Type : public AbstractAllTypes	\
    {	\
        public:	\
            blockName##_Type(std::string name);	\
            ~blockName##_Type();	\
            void getOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);	\
    }


    #define BLOCK_WO( blockName, propName )	\
    class blockName##_Type : public AbstractAllTypes	\
    {	\
        public:	\
            blockName##_Type(std::string name);	\
            ~blockName##_Type();	\
        void setOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);	\
        void setOneDevice(Device* pDevice, propName##PropertyData& data, const bool transmitNow, MultiplexingContext* pContext);	\
    }

    #define BLOCK_RW( blockName, propName )	\
    class blockName##_Type : public AbstractAllTypes	\
    {	\
        public:	\
            blockName##_Type(std::string name);	\
            ~blockName##_Type();	\
            void getOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);	\
            void setOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);	\
            void setOneDevice(Device* pDevice, propName##PropertyData& data, const bool transmitNow, MultiplexingContext* pContext);	\
    }
    
    BLOCK_RO( MyROBlock, MyROBlockProp );
    BLOCK_RW( MyRWBlock, MyRWBlockProp );
    BLOCK_WO( MyWOBlock, MyWOBlockProp );
    BLOCK_WO( MyCBlock, MyCBlockProp );
    
    /*---------------------------------------------------------------------------------------------------------
     * INTERFACE
     *---------------------------------------------------------------------------------------------------------
     * This is the public interface used from the FESA code to access the PLC service.
     */
    class AllTypes
    {
        public:
            static inline Silecs::Service* theService()  { return AbstractAllTypes::theService(); }
            static inline Silecs::Cluster* theCluster()  { return AbstractAllTypes::theCluster(); }
            static void setup(const ServiceLocator* serviceLocator) { AbstractAllTypes::setup(serviceLocator); }
            static void cleanup() { AbstractAllTypes::cleanup(); }
            static bool isInitialized(){ return AbstractAllTypes::isInitialized(); }
            static Silecs::PLC* getPLC(Device* pDevice)
            {
                return AbstractAllTypes::theCluster()->getPLC(pDevice->plcHostName.get());
            }
    
            static MyROBlock_Type MyROBlock;
            static MyRWBlock_Type MyRWBlock;
            static MyWOBlock_Type MyWOBlock;
            static MyCBlock_Type MyCBlock;           
        };
    }

    #endif /* AllTypes_AllTypes_H_ */
    